qlserver 5.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205
  1. #!/bin/bash
  2. # Project: Game Server Managers - LinuxGSM
  3. # Author: Daniel Gibbs
  4. # License: MIT License, Copyright (c) 2016 Daniel Gibbs
  5. # Purpose: Quake Live | Server Management Script
  6. # Contributors: https://github.com/GameServerManagers/LinuxGSM/graphs/contributors
  7. # Documentation: https://github.com/GameServerManagers/LinuxGSM/wiki
  8. # Website: https://gameservermanagers.com
  9. # Debugging
  10. if [ -f ".dev-debug" ]; then
  11. exec 5>dev-debug.log
  12. BASH_XTRACEFD="5"
  13. set -x
  14. fi
  15. version="161224"
  16. ##########################
  17. ######## Settings ########
  18. ##########################
  19. #### Server Settings ####
  20. ## Server Start Settings | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters
  21. arch="x64" # x64 or x86
  22. port="27960"
  23. rconport="28960"
  24. rconpassword="CHANGE_ME"
  25. statsport="${port}"
  26. statspassword="CHANGE_ME"
  27. mappool='mappool.txt'
  28. ip="0.0.0.0"
  29. ## Server Start Command | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters#additional-parameters
  30. # Edit with care | Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  31. # Console Commands : http://www.regurge.at/ql/
  32. fn_parms(){
  33. parms="+set net_strict 1 +set net_ip ${ip} +set net_port ${port} +set fs_homepath ${filesdir}/${port} +set zmq_rcon_enable 1 +set zmq_rcon_port ${rconport} +set zmq_rcon_password ${rconpassword} +set zmq_stats_enable 1 +set zmq_stats_password ${statspassword} +set zmq_stats_port ${statsport} +set sv_mapPoolFile ${mappool} +exec ${servercfg}"
  34. }
  35. #### LinuxGSM Settings ####
  36. ## Notification Alerts
  37. # (on|off)
  38. # Email Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Email
  39. emailalert="off"
  40. email="email@example.com"
  41. emailfrom=""
  42. # Pushbullet Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Pushbullet
  43. pushbulletalert="off"
  44. pushbullettoken="accesstoken"
  45. channeltag=""
  46. ## Updating | https://github.com/GameServerManagers/LinuxGSM/wiki/Update
  47. updateonstart="off"
  48. ## Backup | https://github.com/GameServerManagers/LinuxGSM/wiki/Backup
  49. maxbackups="4"
  50. maxbackupdays="30"
  51. stoponbackup="on"
  52. ## Logging | https://github.com/GameServerManagers/LinuxGSM/wiki/Logging
  53. consolelogging="on"
  54. logdays="7"
  55. #### LinuxGSM Advanced Settings ####
  56. ## SteamCMD Settings
  57. # Server appid
  58. appid="349090"
  59. # Steam App Branch Select
  60. # Allows to opt into the various Steam app branches. Default branch is "".
  61. # Example: "-beta latest_experimental"
  62. branch=""
  63. ## Github Branch Select
  64. # Allows for the use of different function files
  65. # from a different repo and/or branch.
  66. githubuser="GameServerManagers"
  67. githubrepo="LinuxGSM"
  68. githubbranch="master"
  69. ## LinuxGSM Server Details
  70. # Do not edit
  71. gamename="Quake Live"
  72. engine="idtech3_ql"
  73. ## Service Name | https://github.com/GameServerManagers/LinuxGSM/wiki/Multiple-Servers
  74. servicename="ql-server"
  75. #### Directories ####
  76. # Edit with care
  77. ## Work Directories
  78. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  79. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  80. lockselfname=".${servicename}.lock"
  81. lgsmdir="${rootdir}/lgsm"
  82. functionsdir="${lgsmdir}/functions"
  83. libdir="${lgsmdir}/lib"
  84. tmpdir="${lgsmdir}/tmp"
  85. filesdir="${rootdir}/serverfiles"
  86. ## Server Specific Directories
  87. systemdir="${filesdir}"
  88. executabledir="${filesdir}"
  89. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  90. servercfg="${servicename}.cfg"
  91. servercfgdefault="server.cfg"
  92. servercfgdir="${filesdir}/baseq3"
  93. servercfgfullpath="${servercfgdir}/${servercfg}"
  94. ## Backup Directory
  95. backupdir="${rootdir}/backups"
  96. ## Logging Directories
  97. gamelogdir="${rootdir}/log/server"
  98. scriptlogdir="${rootdir}/log/script"
  99. consolelogdir="${rootdir}/log/console"
  100. gamelog="${gamelogdir}/${servicename}-game.log"
  101. scriptlog="${scriptlogdir}/${servicename}-script.log"
  102. consolelog="${consolelogdir}/${servicename}-console.log"
  103. emaillog="${scriptlogdir}/${servicename}-email.log"
  104. ## Logs Naming
  105. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%Y-%m-%d-%H:%M:%S').log"
  106. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%Y-%m-%d-%H:%M:%S').log"
  107. ########################
  108. ######## Script ########
  109. ###### Do not edit #####
  110. ########################
  111. # Fetches core_dl for file downloads
  112. fn_fetch_core_dl(){
  113. github_file_url_dir="lgsm/functions"
  114. github_file_url_name="${functionfile}"
  115. filedir="${functionsdir}"
  116. filename="${github_file_url_name}"
  117. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  118. # If the file is missing, then download
  119. if [ ! -f "${filedir}/${filename}" ]; then
  120. if [ ! -d "${filedir}" ]; then
  121. mkdir -p "${filedir}"
  122. fi
  123. echo -e " fetching ${filename}...\c"
  124. # Check curl exists and use available path
  125. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  126. for curlcmd in ${curlpaths}
  127. do
  128. if [ -x "${curlcmd}" ]; then
  129. break
  130. fi
  131. done
  132. # If curl exists download file
  133. if [ "$(basename ${curlcmd})" == "curl" ]; then
  134. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  135. if [ $? -ne 0 ]; then
  136. echo -e "\e[0;31mFAIL\e[0m\n"
  137. echo "${curlfetch}"
  138. echo -e "${githuburl}\n"
  139. exit 1
  140. else
  141. echo -e "\e[0;32mOK\e[0m"
  142. fi
  143. else
  144. echo -e "\e[0;31mFAIL\e[0m\n"
  145. echo "Curl is not installed!"
  146. echo -e ""
  147. exit 1
  148. fi
  149. chmod +x "${filedir}/${filename}"
  150. fi
  151. source "${filedir}/${filename}"
  152. }
  153. core_dl.sh(){
  154. # Functions are defined in core_functions.sh.
  155. functionfile="${FUNCNAME}"
  156. fn_fetch_core_dl
  157. }
  158. core_functions.sh(){
  159. # Functions are defined in core_functions.sh.
  160. functionfile="${FUNCNAME}"
  161. fn_fetch_core_dl
  162. }
  163. # Prevent from running this script as root.
  164. if [ "$(whoami)" = "root" ]; then
  165. if [ ! -f "${functionsdir}/core_functions.sh" ]||[ ! -f "${functionsdir}/check_root.sh" ]||[ ! -f "${functionsdir}/core_messages.sh" ]||[ ! -f "${functionsdir}/core_exit.sh" ]; then
  166. echo "[ FAIL ] Do NOT run this script as root!"
  167. exit 1
  168. else
  169. core_functions.sh
  170. check_root.sh
  171. fi
  172. fi
  173. core_dl.sh
  174. core_functions.sh
  175. getopt=$1
  176. core_getopt.sh